From dc3654fb30b88e34625058ed922c30cd098315ce Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Oct 11 2017 14:19:40 +0000
Subject: [PATCH 977/1001] Switch from react-loadable to react-universal-component


---

diff --git a/hubs/static/client/app/components/AddWidget/AddWidgetDialog.js b/hubs/static/client/app/components/AddWidget/AddWidgetDialog.js
index 2d48f90..068d1de 100644
--- a/hubs/static/client/app/components/AddWidget/AddWidgetDialog.js
+++ b/hubs/static/client/app/components/AddWidget/AddWidgetDialog.js
@@ -6,10 +6,7 @@ import WidgetSelectDialog from './WidgetSelectDialog';
 import Modal from '../Modal';
 import { getAvailableWidgets } from '../../core/actions/widgets';
 import { addWidget } from '../../core/actions/widget';
-import {
-  makeLoadable,
-  makeLoadingComponent
-} from '../../core/utils';
+import { makeLoadable } from '../../core/utils';
 
 
 class AddWidgetDialog extends React.Component {
@@ -122,10 +119,8 @@ class AddWidgetDialog extends React.Component {
       if (this.state.selectedWidget.isReact) {
         const AsyncComponent = makeLoadable(
           () => import(`../../widgets/${this.state.selectedWidget.name}/Config`),
-          makeLoadingComponent(
-            "Loading widget configuration...",
-            "Sorry, there was a problem loading the widget configuration."
-          )
+          "Loading widget configuration...",
+          "Sorry, there was a problem loading the widget configuration."
         );
         contents = (
           <AsyncComponent
diff --git a/hubs/static/client/app/components/Widget.js b/hubs/static/client/app/components/Widget.js
index 880c1c4..96c5d5b 100644
--- a/hubs/static/client/app/components/Widget.js
+++ b/hubs/static/client/app/components/Widget.js
@@ -1,17 +1,9 @@
 import React from 'react';
 import PropTypes from 'prop-types';
 import { connect } from 'react-redux';
-import {
-  makeLoadable,
-  makeLoadingComponent
-} from '../core/utils';
+import { makeLoadable } from '../core/utils';
 import SimpleWidget from '../components/SimpleWidget';
 
-/*
-import HalpWidget from '../widgets/halp/Widget';
-import FeedWidget from '../widgets/feed/Widget';
-*/
-
 
 class Widget extends React.PureComponent {
 
@@ -30,17 +22,9 @@ class Widget extends React.PureComponent {
     if (!this.props.editMode && this.props.widget.isReact) {
       const AsyncComponent = makeLoadable(
         () => import(`../widgets/${this.props.widget.component}/Widget`),
-        makeLoadingComponent(
-          "Loading widget...",
-          "Sorry, there was a problem loading the widget."
-        )
+        "Loading widget...",
+        "Sorry, there was a problem loading the widget."
       );
-      /*
-      console.log(this.props.widget);
-      let AsyncComponent = null;
-      if (this.props.widget.component === "halp") { AsyncComponent = HalpWidget; }
-      if (this.props.widget.component === "feed") { AsyncComponent = FeedWidget; }
-      */
       widgetComponent = (
         <AsyncComponent {...this.props} />
       );
diff --git a/hubs/static/client/app/components/WidgetConfigDialog.js b/hubs/static/client/app/components/WidgetConfigDialog.js
index 1548956..1a8bd33 100644
--- a/hubs/static/client/app/components/WidgetConfigDialog.js
+++ b/hubs/static/client/app/components/WidgetConfigDialog.js
@@ -6,10 +6,7 @@ import {
   deleteWidget,
   closeConfigDialog,
   } from "../core/actions/widget";
-import {
-  makeLoadable,
-  makeLoadingComponent
-} from '../core/utils';
+import { makeLoadable } from '../core/utils';
 import SimpleWidgetConfig from '../components/SimpleWidgetConfig';
 import Modal from '../components/Modal';
 
@@ -72,10 +69,8 @@ class WidgetConfigDialog extends React.Component {
     if (this.props.widget.isReact) {
       const AsyncComponent = makeLoadable(
         () => import(`../widgets/${widgetName}/Config`),
-        makeLoadingComponent(
-          "Loading widget configuration...",
-          "Sorry, there was a problem loading the widget configuration."
-        )
+        "Loading widget configuration...",
+        "Sorry, there was a problem loading the widget configuration."
       );
       contents = (
         <AsyncComponent
diff --git a/hubs/static/client/app/core/Pages.js b/hubs/static/client/app/core/Pages.js
index def36e4..6277719 100644
--- a/hubs/static/client/app/core/Pages.js
+++ b/hubs/static/client/app/core/Pages.js
@@ -1,26 +1,19 @@
 import React from 'react';
 import {
   makeLoadable,
-  makeLoadingComponent
 } from '../core/utils';
 
 
-const PageLoadingComponent = makeLoadingComponent(
-  "Loading...",
-  "Sorry, there was a problem loading the page."
-);
-
-
 let Hub = makeLoadable(
   () => import(/* webpackChunkName: "page-hub" */ '../components/HubPage'),
-  PageLoadingComponent
+  "Loading...",
+  "Sorry, there was a problem loading the page."
 );
 let Streams = makeLoadable(
   () => import(/* webpackChunkName: "page-streams" */ '../components/StreamsPage'),
-  PageLoadingComponent
+  "Loading...",
+  "Sorry, there was a problem loading the page."
 );
 
-//Hub = require('../components/HubPage').default;
-//Streams = require('../components/StreamsPage').default;
 
 export {Hub, Streams};
diff --git a/hubs/static/client/app/core/utils.js b/hubs/static/client/app/core/utils.js
index 0699a93..d3dd241 100644
--- a/hubs/static/client/app/core/utils.js
+++ b/hubs/static/client/app/core/utils.js
@@ -1,6 +1,6 @@
 import React from 'react';
 import fetch from 'isomorphic-fetch';
-import Loadable from 'react-loadable';
+import universal from 'react-universal-component'
 
 
 export function backendCall(url, fetchConfig, json=false) {
@@ -38,51 +38,44 @@ export function apiCall(url, fetchConfig) {
 }
 
 
-export function makeLoadable(loader, loading) {
-  const renderDefault = (loaded, props) => {
-    const Component = loaded.default;
-    return <Component {...props} />;
-  }
-  return Loadable({
-    loader,
-    loading,
-    render: renderDefault,
-    delay: 200,
+export function makeLoadable(loader, loadingText, errorText) {
+  //return makeSyncLoadable(loader);
+  const LoadingComponent = () => (
+    <div className="text-muted">
+      {loadingText}
+    </div>
+  );
+  const ErrorComponent = ({ error }) => (
+    <div>
+      {error ? error.message : errorText}
+    </div>
+  );
+  const AsyncComponent = universal(loader, {
+    loading: LoadingComponent,
+    error: ErrorComponent
   });
+  return AsyncComponent;
 }
 
-export function makeLoadingComponent(loadingText, errorText) {
-  class LoadingComponent extends React.Component {
+function makeSyncLoadable(loader) {
+  class SyncLoadable extends React.Component {
+    constructor(props) {
+      super(props);
+      this.state = {component: null}
+    }
+    componentDidMount() {
+      loader().then((module) => {
+        this.setState({component: module.default});
+      }).catch((error) => {
+        console.error(error);
+      });
+    }
     render() {
-      // Handle the loading state
-      if (this.props.isLoading) {
-        if (this.props.timedOut) {
-          // In case we've timed out loading our other component.
-          return <div className="text-warning">Loader timed out!</div>;
-        } else if (this.props.pastDelay) {
-          // Display a loading screen after a set delay.
-          return (
-            <div className="text-muted">
-              {loadingText}
-            </div>
-          );
-        } else {
-          // Don't flash "Loading..." when we don't need to.
-          return null;
-        }
-      }
-      // Handle the error state
-      else if (this.props.error) {
-        return (
-          <div>
-            {errorText}
-          </div>
-        );
-      }
-      else {
+      if (!this.state.component) {
         return null;
       }
+      return <this.state.component {...this.props} />;
     }
   }
-  return LoadingComponent;
+  return SyncLoadable;
 }
diff --git a/hubs/static/client/app/widgets/feed/Widget.js b/hubs/static/client/app/widgets/feed/Widget.js
index 31e6f6f..fdecb36 100644
--- a/hubs/static/client/app/widgets/feed/Widget.js
+++ b/hubs/static/client/app/widgets/feed/Widget.js
@@ -8,7 +8,7 @@ import Feed from '../../components/feed/Feed';
 import WidgetChrome from '../../components/WidgetChrome';
 
 
-export default class Widget extends React.PureComponent {
+export default class FeedWidget extends React.PureComponent {
 
   propTypes: {
     widget: PropTypes.object.isRequired,
diff --git a/hubs/static/client/app/widgets/halp/Widget.js b/hubs/static/client/app/widgets/halp/Widget.js
index 099adb2..8f54123 100644
--- a/hubs/static/client/app/widgets/halp/Widget.js
+++ b/hubs/static/client/app/widgets/halp/Widget.js
@@ -37,7 +37,7 @@ const messages = defineMessages({
 });
 
 
-export default class Widget extends React.Component {
+export default class HalpWidget extends React.Component {
 
   propTypes: {
     widget: PropTypes.object.isRequired,
